//-----------------------------------------------------------------------------
/*!
   \file           cb.h
   \brief          header for circular buffer

   \implementation
    project       Wens 700 display
    version       0.00
    generated     Matthias Koelling 23.10.2021
    compiler      AVR GCC
    target        ATmega164
   \endimplementation
*/
//-----------------------------------------------------------------------------

#ifndef CB_H
#define CB_H

/* -- Includes ------------------------------------------------------------- */

#include <stddef.h>
#include <stdbool.h>

/* -- Configuration Parameters --------------------------------------------- */

/* -- Defines -------------------------------------------------------------- */

/* -- Types ---------------------------------------------------------------- */

typedef struct circular_buffer
{
    void* pv_buffer;     // data buffer
    void* pv_buffer_end; // end of data buffer
    size_t t_capacity;  // maximum number of items in the buffer
    size_t t_count;     // number of items in the buffer
    size_t t_size;        // size of each item in the buffer
    void* pv_head;       // pointer to head
    void* pv_tail;       // pointer to tail
}
T_circular_buffer;

/* -- Extern Global Variables ---------------------------------------------- */

/* -- Global Function Prototypes ------------------------------------------- */

extern void cb_init (T_circular_buffer* opt_cb, size_t opt_capacity, size_t opt_size);
extern void cb_free (T_circular_buffer* opt_cb);
extern void cb_push_back (T_circular_buffer* opt_cb, const void* opv_item);
extern bool cb_pop_front (T_circular_buffer* opt_cb, void* opv_item);

#endif // CB_H

// EOF
