//-----------------------------------------------------------------------------
/*!
   \file          ioport.c
   \brief         port initialization


   \implementation
    project       Wens700 Display
    version       0.00
    generated     Matthias Koelling 03.10.2021
    compiler      AVR GCC
    target        ATmega164
   \endimplementation
*/
//-----------------------------------------------------------------------------

/* -- Configuration Parameters --------------------------------------------- */

#define IOPORT_C

/* -- Includes ------------------------------------------------------------- */

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "ioport.h"

/* -- Makros --------------------------------------------------------------- */

/* -- Defines -------------------------------------------------------------- */

/* -- Types ---------------------------------------------------------------- */

/* -- Module Global Variables ---------------------------------------------- */

/* -- Extern Global Variables ---------------------------------------------- */

/* -- Makros --------------------------------------------------------------- */

/* -- Implementation Functions --------------------------------------------- */

//-----------------------------------------------------------------------------
/*!
   \brief      ioport_init

               port initialization

   \author     Koelling
   \date       07.06.2008

   \param[in]  void
   \param[out] none
   \return     void
*/
//-----------------------------------------------------------------------------
void ioport_init (void)
{
   DDRA = 0xFF;
   DDRB = 0x1F;
   DDRC = 0x00;
   DDRD = 0x02;
}


// EOF
